
//--------------------------------------------------------------------
//     此代码由liquid模板自动生成  byzhouhang 20240909
//     生成时间 2024-10-10 08:28:28Z 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
//--------------------------------------------------------------------
using IRaCIS.Core.Domain.Models;
using Microsoft.AspNetCore.Mvc;
using IRaCIS.Core.Application.Interfaces;
using IRaCIS.Core.Application.ViewModel;
using IRaCIS.Core.Infrastructure.Extention;
using System.Threading.Tasks;
using IRaCIS.Core.Infra.EFCore;
using MassTransit.Mediator;
using Newtonsoft.Json;
using MassTransit;
using IRaCIS.Core.Domain;
namespace IRaCIS.Core.Application.Service;

[ApiExplorerSettings(GroupName = "Common")]
public class EventStoreRecordService(IRepository<EventStoreRecord> _eventStoreRecordRepository, IMediator _mediator) : BaseService
{

    [HttpPost]
    public async Task<PageOutput<EventStoreRecordView>> GetEventStoreRecordList(EventStoreRecordQuery inQuery)
    {

        var eventStoreRecordQueryable = _eventStoreRecordRepository
                                    .ProjectTo<EventStoreRecordView>(_mapper.ConfigurationProvider);

        var pageList = await eventStoreRecordQueryable.ToPagedListAsync(inQuery);

        return pageList;
    }


    public async Task<IResponseOutput> RePublishEvent(Guid eventId)
    {
        var storedEvent = await _eventStoreRecordRepository.FirstOrDefaultAsync(t => t.Id == eventId);

        var domainEvent = storedEvent.EventData.JsonStrToObject(Type.GetType(storedEvent.EventType));

        Console.WriteLine(Type.GetType(storedEvent.EventType));
       
        Console.WriteLine(domainEvent.GetType());

        Console.WriteLine(new UserSiteSurveySubmitedEvent().GetType().AssemblyQualifiedName);

        await _mediator.Publish(domainEvent.GetType(), domainEvent);

        return ResponseOutput.Ok();

    }
}



